echo "\n"
echo "***********************************************"
echo "3. Fluxos de Trabalho - Workflows StepFunctions"
echo "***********************************************"
echo " "

echo "3.2 Criaçao do fluxo de trabalho Fluxo de Pagamento"

echo " "\
"{ \n" \
"  \"Comment\": \"Exemplo de fluxo de pagamento via cartao de crédito\", \n" \
"  \"StartAt\": \"Validar CPF\", \n" \
"  \"States\": { \n" \
"     \"Validar CPF\": { \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \""$(cat /tmp/LambdaValidaCPFArn)"\", \n" \
"      \"Next\": \"Efetuar Pagamento\" \n" \
"    }, \n" \
"     \"Efetuar Pagamento\": { \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \""$(cat /tmp/LambdaExecutarPagamentoArn)"\", \n" \
"      \"End\": true \n" \
"    } \n" \
"  } \n" \
"}" > /tmp/FluxoFazerPagamento.json

aws stepfunctions create-state-machine --name SFDemoFluxoFazerPagamento --definition "$(cat /tmp/FluxoFazerPagamento.json)" --role-arn "$(cat /tmp/statesExecutionoRoleArn)" --output text --query 'stateMachineArn' > /tmp/stateMachineFazerPagamentoArn

echo "3.2.1 (Opcional) Chamar o fluxo de trabalho (FazerPagamento) para verificar esta funcionando"

aws stepfunctions start-execution --state-machine-arn "$(cat /tmp/stateMachineFazerPagamentoArn)" --output text --query "executionArn"

echo "\n3.3 Criação do Fluxo de trabalho de Reservar Hotel"

echo " "\
"{ \n" \
"  \"Comment\": \"Exemplo de fluxo de Reservar Hotel\", \n" \
"  \"StartAt\": \"Validar Disponibilidade Quarto\", \n" \
"  \"States\": { \n" \
"     \"Validar Disponibilidade Quarto\": { \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \""$(cat /tmp/LambdaValidarDisponibilidadeQuartoArn)"\", \n" \
"      \"Next\": \"Reservar Hotel\" \n" \
"    }, \n" \
"     \"Reservar Hotel\": { \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \""$(cat /tmp/LambdaReservarHotelArn)"\", \n" \
"      \"Next\": \"Fazer Pagamento\" \n" \
"    }, \n" \
"      \"Fazer Pagamento\": { \n" \
"      \"Comment\": \"Inicia uma execução de outra máquina de estado e continua - Fazer Pagamento\", \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \"arn:aws:states:::states:startExecution\", \n" \
"      \"Parameters\": { \n" \
"        \"StateMachineArn\": \""$(cat /tmp/stateMachineFazerPagamentoArn)"\", \n" \
"        \"Input\": { \n" \
"          \"NeedCallback\": false \n" \
"        } \n" \
"      }, \n" \
"      \"End\": true \n" \
"      } \n" \
"  } \n" \
"}" > /tmp/FluxoReservarHotel.json

aws stepfunctions create-state-machine --name SFDemoReservarHotel --definition "$(cat /tmp/FluxoReservarHotel.json)" --role-arn "$(cat /tmp/statesExecutionoRoleArn)" --output text --query 'stateMachineArn' > /tmp/stateMachineReservarHotelArn

echo "3.3.1 (Opcional) Chamar o fluxo de trabalho (ReservarHotel) para verificar esta funcionando"

aws stepfunctions start-execution --state-machine-arn "$(cat /tmp/stateMachineReservarHotelArn)" --output text --query "executionArn"

echo "\n3.4 Criação do Fluxo de trabalho de Reservar Passagem"

echo " "\
"{ \n" \
"  \"Comment\": \"Exemplo de fluxo de Reservar Passagem\", \n" \
"  \"StartAt\": \"Comprar Passagem Aerea\", \n" \
"  \"States\": { \n" \
"     \"Comprar Passagem Aerea\": { \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \""$(cat /tmp/LambdaComprarPassagemAereaArn)"\", \n" \
"      \"Next\": \"Fazer Pagamento\" \n" \
"    }, \n" \
"      \"Fazer Pagamento\": { \n" \
"      \"Comment\": \"Inicia uma execução de outra máquina de estado e continua - Fazer Pagamento\", \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \"arn:aws:states:::states:startExecution\", \n" \
"      \"Parameters\": { \n" \
"        \"StateMachineArn\": \""$(cat /tmp/stateMachineFazerPagamentoArn)"\", \n" \
"        \"Input\": { \n" \
"          \"NeedCallback\": false \n" \
"        } \n" \
"      }, \n" \
"      \"End\": true \n" \
"      } \n" \
"  } \n" \
"}" > /tmp/FluxoReservarPassagem.json

aws stepfunctions create-state-machine --name SFDemoReservarPassagem --definition "$(cat /tmp/FluxoReservarPassagem.json)" --role-arn "$(cat /tmp/statesExecutionoRoleArn)" --output text --query 'stateMachineArn' > /tmp/stateMachineReservarPassagemArn

echo "3.4.1 (Opcional) Chamar o fluxo de trabalho (ReservarPassagem) para verificar esta funcionando"

aws stepfunctions start-execution --state-machine-arn "$(cat /tmp/stateMachineReservarPassagemArn)" --output text --query "executionArn"

echo "\n3.5 Criação do Fluxo de Trabalho de Reservar Carro"

echo " "\
"{ \n" \
"  \"Comment\": \"Exemplo de fluxo de Reservar Carro\", \n" \
"  \"StartAt\": \"Reservar Carro\", \n" \
"  \"States\": { \n" \
"     \"Reservar Carro\": { \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \""$(cat /tmp/LambdaReservarCarroArn)"\", \n" \
"      \"End\": true \n" \
"      } \n" \
"  } \n" \
"}" > /tmp/FluxoReservarCarro.json

aws stepfunctions create-state-machine --name SFDemoReservarCarro --definition "$(cat /tmp/FluxoReservarCarro.json)" --role-arn "$(cat /tmp/statesExecutionoRoleArn)" --output text --query 'stateMachineArn' > /tmp/stateMachineReservarCarroArn

echo "3.5.1 (Opcional) Chamar o fluxo de trabalho (ReservarCarro) para verificar esta funcionando"

aws stepfunctions start-execution --state-machine-arn "$(cat /tmp/stateMachineReservarCarroArn)" --output text --query "executionArn"

echo "\n3.5. Criação do Fluxo de Trabalho - Reservar Viagem (Principal)"

echo " "\
"{ \n" \
"  \"Comment\": \"Exemplo de fluxo (principal) de Reservar Viagem\", \n" \
"  \"StartAt\": \"Validar Dados da Viagem\", \n" \
"  \"States\": { \n" \
"     \"Validar Dados da Viagem\": { \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \""$(cat /tmp/LambdaValidarDadosDaViagemArn)"\", \n" \
"      \"Next\": \"Reservar Hotel\" \n" \
"    }, \n" \
"      \"Reservar Hotel\": { \n" \
"      \"Comment\": \"Inicia uma execução de outra máquina de estado e continua - Reservar Hotel\", \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \"arn:aws:states:::states:startExecution\", \n" \
"      \"Parameters\": { \n" \
"        \"StateMachineArn\": \""$(cat /tmp/stateMachineReservarHotelArn)"\", \n" \
"        \"Input\": { \n" \
"          \"NeedCallback\": false \n" \
"         } \n" \
"      }, \n" \
"      \"Next\": \"Reservar Passagem\" \n" \
"    }, \n" \
"      \"Reservar Passagem\": { \n" \
"      \"Comment\": \"Inicia uma execução de outra máquina de estado e continua - Reservar Passagem\", \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \"arn:aws:states:::states:startExecution\", \n" \
"      \"Parameters\": { \n" \
"        \"StateMachineArn\": \""$(cat /tmp/stateMachineReservarPassagemArn)"\", \n" \
"        \"Input\": { \n" \
"          \"NeedCallback\": false \n" \
"        } \n" \
"      }, \n" \
"      \"Next\": \"Reservar Carro\" \n" \
"    }, \n" \
"      \"Reservar Carro\": { \n" \
"      \"Comment\": \"Inicia uma execução de outra máquina de estado e continua - Reservar Carro\", \n" \
"      \"Type\": \"Task\", \n" \
"      \"Resource\": \"arn:aws:states:::states:startExecution\", \n" \
"      \"Parameters\": { \n" \
"        \"StateMachineArn\": \""$(cat /tmp/stateMachineReservarCarroArn)"\", \n" \
"        \"Input\": { \n" \
"          \"NeedCallback\": false \n" \
"        } \n" \
"      }, \n" \
"      \"End\": true \n" \
"    } \n" \
"  } \n" \
"}" > /tmp/FluxoReservarViagem.json

aws stepfunctions create-state-machine --name SFDemoReservarViagemPRINCIPAL --definition "$(cat /tmp/FluxoReservarViagem.json)" --role-arn "$(cat /tmp/statesExecutionoRoleArn)" --output text --query 'stateMachineArn' > /tmp/stateMachineReservarViagemArn

echo "3.5.1 (Opcional) Chamar o fluxo de trabalho (ReservarViagem - Principal) para verificar esta funcionando"

aws stepfunctions start-execution --state-machine-arn "$(cat /tmp/stateMachineReservarViagemArn)" --input "{ \"Origem\": \"Sao Paulo\", \"Destino\": \"Nova Iorque\", \"Data\": \"15/04/2022\", \"NumeroPessoas\": 2, \"ReservarCarro\": true }"